#include "module.h"
#define AUTHOR "DrStein" /* Based on ns_listbypass.c by DaPrivateer */
#define MYNAME "ns_dropby"
#define VERSION "0.0.2"

/* --------------------------------------------
 * MODULE AUTHOR AND RELEASE DATE
 * --------------------------------------------
 * Name: ns_dropby
 * Author: DrStein <gacevedo@anope.org>
 * Date: 05-04-2004
 *
 * --------------------------------------------
 * MODULE SUPPORT
 * --------------------------------------------
 * Tested on Unreal 3.2, but supports all IRCds
 *  which Anope support.
 *
 * --------------------------------------------
 * MODULE DESCRIPTION
 * --------------------------------------------
 * This module add two new commands to NickServ
 * The command provide the way to delete 
 * nicknames by matching with a given e-mail 
 * or password.
 *
 * --------------------------------------------
 * CHANGELOG
 * --------------------------------------------
 * v0.0.2 - Fixed a bug related to a bucle.
 * v0.0.1 - Initial release.
 * 
*/

/* -------------------------------------------- 
 * HELP strings - Don't remove the %s
 * --------------------------------------------
*/ 

#define DP_BYPASS_SYNTAX "Sytanx: \002/msg NickServ DROPBYPASS \037password\037\002"
#define DP_BYEMAIL_SYNTAX "Syntax: \002/msg NickServ DROPBYEMAIL \037email\037\002"

/* ---------------------------------------------
 * Please don't edit anything below here.
 * ---------------------------------------------
*/

int m_dropbypass(User *u);
int m_dropbyemail(User *u);
int DP_E_Help(User *u);
int DP_P_Help(User *u);
void DP_NS_Help(User *u);

void AnopeInit(void) {
	int status=0;
	Command *c=NULL;

	c = createCommand("DROPBYPASS", m_dropbypass, is_services_admin,-1,-1,-1,-1,-1);
    status += moduleAddCommand(NICKSERV, c, MOD_TAIL);
	moduleAddHelp(c,DP_P_Help);

	c = createCommand("DROPBYEMAIL", m_dropbyemail, is_services_admin,-1,-1,-1,-1,-1);
    status += moduleAddCommand(NICKSERV, c, MOD_TAIL);
	moduleAddHelp(c,DP_E_Help);

    if (status == 0) {
        alog("[%s.so] Loaded successfully", MYNAME);
    } else {
        alog("[%s.so] FAILED to load - result %d", MYNAME, status);
    }

	moduleSetNickHelp(DP_NS_Help);

	moduleAddAuthor(AUTHOR);
	moduleAddVersion(VERSION);
}

void AnopeFini(void) {
	alog("LogServ: module unloaded");
}

int m_dropbypass(User *u) {
	NickCore *nc;
	NickAlias *na;
	char *args=NULL;
	char *pass=NULL;
	int i, e, delcount = 0, notdeleted = 0;

	if (!u)
		return MOD_CONT;

	if (moduleGetLastBuffer()) {
		args = sstrdup(moduleGetLastBuffer());
		pass = myStrGetToken(args,' ',0);
	} else {
		notice(s_NickServ, u->nick, DP_BYPASS_SYNTAX);
		return MOD_CONT;
	}

	for (i=0; i < 1024; i++) {
		nc = nclists[i];		
		while (nc) {
			if (nc->pass && !stricmp(nc->pass,pass) && nc->display) {
				for (e = 0; e < nc->aliases.count; e++) {
					na = nc->aliases.list[e];
					if (NSSecureAdmins && nick_is_services_admin(na->nc)
						&& !is_services_root(u)) {
						notdeleted++;
               				} else {
						delnick(na);
						delcount++;
					}
				}
			}
			nc = nc->next;
		}
	}
	
	notice(s_NickServ, u->nick, "%d nicknames deleted.", delcount);
	if (notdeleted > 0) {
		notice(s_NickServ, u->nick, "%d nicknames left. They are Services Admin", notdeleted);
	}

	return MOD_CONT;
}

int m_dropbyemail(User *u) {
	NickCore *nc;
	NickAlias *na;
	char *args=NULL;
	char *email=NULL;
	int i, e, delcount = 0, notdeleted = 0;

	if (!u)
		return MOD_CONT;

	if (moduleGetLastBuffer()) {
		args = sstrdup(moduleGetLastBuffer());
		email = myStrGetToken(args,' ',0);
	} else {
		notice(s_NickServ, u->nick, DP_BYEMAIL_SYNTAX);
		return MOD_CONT;
	}

	for (i=0; i < 1024; i++) {
		nc = nclists[i];		
		while (nc) {
			if (nc->email && !stricmp(nc->email,email) && nc->display) {
				for (e = 0; i < nc->aliases.count; e++) {
					na = nc->aliases.list[i];
					if (NSSecureAdmins && nick_is_services_admin(na->nc)
						&& !is_services_root(u)) {
						notdeleted++;
               				} else {
						delnick(na);
						delcount++;
					}
				}
			}
			nc = nc->next;
		}
	}
	
	notice(s_NickServ, u->nick, "%d nicknames deleted.", delcount);
	if (notdeleted > 0) {
		notice(s_NickServ, u->nick, "%d nicknames left. They are Services Admin", notdeleted);
	}

	return MOD_CONT;
}

int DP_P_Help(User *u) {
	notice(s_NickServ, u->nick, DP_BYPASS_SYNTAX);
	notice(s_NickServ, u->nick, "\002\002");
	notice(s_NickServ, u->nick, "drop nicks based on their password");

	return MOD_CONT;

}

int DP_E_Help(User *u) {
	notice(s_NickServ, u->nick, DP_BYEMAIL_SYNTAX);
	notice(s_NickServ, u->nick, "\002\002");
	notice(s_NickServ, u->nick, "drop nicks based on their e-mails");

	return MOD_CONT;

}

void DP_NS_Help(User *u) {
	if (is_services_admin(u)) {
		notice(s_NickServ, u->nick, "    DROPBYPASS    Drop nicks by password");
		notice(s_NickServ, u->nick, "    DROPBYEMAIL   Drop nicks by e-mail");
	}

	return;
}

/* EOF */

